!     Copyright (c) M. Yas'ko. E-mail: yasko@ftf.dsu.dp.ua
! include 'psfmt.f90'
PROGRAM EPS_DEMO
  USE PSFMT
  USE RGBcolors
  IMPLICIT NONE
    REAL :: XO=.15, YO=.9, RAD=15. ! Radius (mm)
    integer :: i
      OPEN(UNIT=17, FILE='DEMO.EPS', POSITION='rewind', ERR=11111)
      WRITE(17,PROLOG,ERR=22222) EPSF
      WRITE(17,BeginPage) 
!----------Set RGB color - BLACK  is array from 3 elements ------
      WRITE(17,COLOR)  BLACK
!----------------------------------------------------------------
!------- Set font Times-Bold, 36pt -----------------------------
      WRITE(17,FONT) 'Times-Bold', 36
!----------------------------------------------------------------
!---------- Write text: Title -----------------------------------
      WRITE(17,TEXT) 0.504,0.953, 'EPS_Demo', 'cc' ! "cc" is as in LaTeX
      WRITE(17,COLOR)  RED
      WRITE(17,TEXT) 0.5,0.95, 'EPS_Demo', 'cc'
!----------------------------------------------------------------
!----------Set Line Style - LineWidth [,LineType]----------------
      WRITE(17,LineType) Thin, Solid
!------- Filed Circle (disk) (radius - in mm) -------------------
      WRITE(17,COLOR)  Yellow
      WRITE(17,CIRCLE) CMPLX(XO,YO),RAD,Filled
      WRITE(17,COLOR)  YELLOW*0.9
      WRITE(17,CIRCLE) CMPLX(XO,YO),RAD ! Hollow circle
!----------------------------------------------------------------
!-------- Arrows (8) ---------------------------------------------
      WRITE(17,ARROW) ( CMPLX(XO,YO)+.1*EXP((0.,-.3)*i), CMPLX(XO,YO)+.2*EXP((0.,-.3)*i), i=0,7)
!----------------------------------------------------------------
      WRITE(17,COLOR) 0., 0.9, 0.9
      WRITE(17,RECTAN) 20., 50., 100.,100.
      WRITE(17,COLOR) BLACK
      WRITE(17,SetViewPort) 20.,50., 100.,100.
      WRITE(17,SetCoOrd) -2., 2.,  -2.,2.
      WRITE(17,ARROW)  -1.9, 0.,   1.9, 0.
      WRITE(17,ARROW)  0.,-1.9,    0., 1.9
      WRITE(17,LineType) Thick, Solid
      
      WRITE(17,PolyLine) (((.1*i)**2-1)/((.1*i)**2+1),.1*i*((.1*i)**2-1)/((.1*i)**2+1), i=-40,40)
      WRITE(17,LineType) Thin, Dashed
      WRITE(17,PolyLine)  1.,-1.9, 1., 1.9

!----------------------------------------------------------------
!------------- It is END of page --------------------------------
      WRITE(17,ENDPAGE) Epilog ! Epilog must be for the end of file
!----------------------------------------------------------------
      CLOSE(17,ERR=22222)
      STOP
11111 STOP 'Bad file name'
22222 STOP 'Error writing EPSF'
END PROGRAM EPS_DEMO
