!     Copyright (c) M. Yas'ko. E-mail: yasko@ftf.dsu.dp.ua
! include 'psfmt.f90'
PROGRAM POSTSCRIPT_DEMO
  USE PSFMT
  USE RGBcolors
  IMPLICIT NONE
    REAL, DIMENSION(4) :: X=(/.03,.69,.95,.35/), Y=(/.46,.48,.52,.53/)
    REAL, DIMENSION(4) :: XT=(/.3,.32,.32,.3/), YT=(/.5,.5,.6,.6/)
    REAL, DIMENSION(5) :: XC=(/.29,.33,.3,.32,.31/), YC=(/.56,.56,.58,.58,.59/)
    REAL :: XO=.15, YO=.9, RAD=15. ! Radius (mm)
    integer :: i
      OPEN(UNIT=17, FILE='DEMO.PS', POSITION='rewind', ERR=11111)
      WRITE(17,PROLOG,ERR=22222) POSTSCRIPT, WithMathText
      WRITE(17,BeginPage) 1
!-- Write hollow rectangle in point (0,0) with sides 180,240mm --
      WRITE(17,Rectan) 0.,0.,180.,240.
!----------Set RGB color - BLACK  is array from 3 elements ------
      WRITE(17,COLOR)  BLACK
!----------------------------------------------------------------
!------- Set font Times-Bold, 36pt -----------------------------
      WRITE(17,FONT) 'Times-Bold', 36
!----------------------------------------------------------------
!---------- Write text: Title -----------------------------------
      WRITE(17,TEXT) 0.504,0.953, 'PostScript_Demo', 'cc' ! "cc" is as in LaTeX
      WRITE(17,COLOR)  RED
      WRITE(17,TEXT) 0.5,0.95, 'PostScript_Demo', 'cc'
!----------------------------------------------------------------
!----------Set Line Style - LineWidth [,LineType]----------------
      WRITE(17,LineType) Thin, Solid
!------- Filed Circle (disk) (radius - in mm) -------------------
      WRITE(17,COLOR)  Yellow
      WRITE(17,CIRCLE) CMPLX(XO,YO),RAD,Filled
      WRITE(17,COLOR)  YELLOW*0.9
      WRITE(17,CIRCLE) CMPLX(XO,YO),RAD ! Hollow circle
!----------------------------------------------------------------
!-------- Arrows (8) ---------------------------------------------
      WRITE(17,ARROW) ( CMPLX(XO,YO)+.1*EXP((0.,-.3)*i), CMPLX(XO,YO)+.2*EXP((0.,-.3)*i), i=0,7)
!----------------------------------------------------------------
      WRITE(17,COLOR)  Blue
!------- Circle (radius in mm) ----------------------------------
      WRITE(17,CIRCLE) .6,.8,   14., Filled
      WRITE(17,CIRCLE) .5,.78,  14., Filled
      WRITE(17,CIRCLE) .71,.82, 14., Filled
      WRITE(17,CIRCLE) .55,.76, 14., Filled
      WRITE(17,CIRCLE) .53,.81, 14., Filled
      WRITE(17,CIRCLE) .66,.84, 14., Filled
      WRITE(17,CIRCLE) .60,.83, 14., Filled
!--------- Set LineType: .1pt, Dashed line ---------------------
      WRITE(17,LineType) Thin, Dashed
!----------------------------------------------------------------
!----------- PolyLine -------------------------------------------
      WRITE(17,PolyLine) .55,.65, .55,.45
      WRITE(17,PolyLine) .65,.68, .65,.48
      WRITE(17,PolyLine) .75,.72, .75,.49
      WRITE(17,LineType) Thick, Solid
!----------------------------------------------------------------
!------------ New co-ordinates Xmin,Xmax, Ymin,Ymax -------------
!---- (default coordinates is   0  - 1      0 - 1  ) ------------
      WRITE(17,SetCoOrd) 0., 180.,   0.,240.  ! Now in mm
!----------------------------------------------------------------
!------- Set font Helvetica, 12pt (default) ---------------------
      WRITE(17,FONT) 'Helvetica'
      WRITE(17,COLOR)  Black
      WRITE(17,TEXT) 170.,10., 'x', 'tc'   ! Alignment (top, center)
      WRITE(17,TEXT)  90.,90., 'y', 'cr'   ! Alignment (center, right)
      WRITE(17,TEXT)  90.,10., 'O', 'tr'   ! Alignment (top, right)
      WRITE(17,TEXT) 130., 5., 'Fig. Parabola', 'cc'

!-------- Set ViewPort  (Xo,Yo, DX,DY in mm) ------------
      WRITE(17,SetViewPort) 90.,10.,80.,80.
!----------------------------------------------------------------
      WRITE(17,COLOR)  BLACK
      WRITE(17,Rectan) 90.,10.,80.,80.
!-------- Set co-ordinates (Xmin,Xmax, Ymin,Ymax) ---------------
      WRITE(17,SetCoOrd) 0., 1.,  0.,1. ! co-ordinates for new viewport
!----------------------------------------------------------------
      WRITE(17,MathText) 0.15,0.60, 'y_@a| = x^2|'
      WRITE(17,PolyLine) (i*0.05,(i*0.05)**2, I=0,20) ! Across 21 points
      WRITE(17,Marker) 0.1, 0.06, Dot
      WRITE(17,Marker) 0.2, 0.025, Bullet
      WRITE(17,Marker) 0.3, 0.11, Plus
      WRITE(17,Marker) 0.4, 0.14, Times
      WRITE(17,Marker) 0.5, 0.27, Circ,     0.6, 0.39, ast
      WRITE(17,Marker) 0.7, 0.52, dimond

      WRITE(17,SetViewPort)     ! Restore old viewport and graphics state

      WRITE(17,COLOR)  0.56 ! Set gray color
!----------------------------------------------------------------

!----------- Filled POLIGON -------------------------------------
      WRITE(17,COLOR)  GREEN
      WRITE(17,SHADE) ( X(I),Y(I), I=1,4)
!     WRITE(17,POLYGON) ( X(I),Y(I), I=1,4)
      WRITE(17,COLOR)  0.15  ! GrayColor!
      WRITE(17,POLYGON)  X(1),Y(1)-0.02, X(2),Y(2)-0.02, X(2),Y(2), X(1),Y(1)
      WRITE(17,COLOR)  0.30  ! GrayColor!
      WRITE(17,POLYGON)  X(2),Y(2)-0.02, X(3),Y(3)-0.02, X(3),Y(3), X(2),Y(2)
      WRITE(17,COLOR)  BRAWN
      WRITE(17,POLYGON) ( XT(I),YT(I), I=1,4)
      WRITE(17,COLOR)  GREEN*0.8
      WRITE(17,CIRCLE) (XC(I),YC(I), 6., Filled, I=1,5)

      WRITE(17,FONT) 'Times-Roman', 16
      WRITE(17,TEXT) 0.2,0.41, 'Poligons', 'cc',10   ! Angle is 10 degrees
      WRITE(17,COLOR) 0.
      WRITE(17,FONT) 'Times-Italic', 14
      WRITE(17,TEXT) 0.05,0.30, 'I hope, this example of vector'
      WRITE(17,TEXT) 0.05,0.26, 'postscript graphics will be useful'
      WRITE(17,TEXT) 0.05,0.22, 'for users of Fortran-90.'
      WRITE(17,TEXT) 0.20,0.18, "Nick Yas'ko"
!------------- It is END of page --------------------------------
      WRITE(17,ENDPAGE)
!------------- Second page --------------------------------------
      WRITE(17,BeginPage) 2
      WRITE(17,COLOR) 0., 0.9, 0.9
      WRITE(17,RECTAN) 20., 50., 100.,100., Filled
      WRITE(17,COLOR) BLACK
      WRITE(17,SetViewPort) 20.,50., 100.,100.
      WRITE(17,SetCoOrd) -2., 2.,  -2.,2.
      WRITE(17,ARROW)  -1.9, 0.,   1.9, 0.
      WRITE(17,ARROW)  0.,-1.9,    0., 1.9
      WRITE(17,LineType) Thick, Solid
      
      WRITE(17,PolyLine) (((.1*i)**2-1)/((.1*i)**2+1),.1*i*((.1*i)**2-1)/((.1*i)**2+1), i=-40,40)
      WRITE(17,LineType) Thin, Dashed
      WRITE(17,PolyLine)  1.,-1.9, 1., 1.9

!----------------------------------------------------------------
!------------- It is END of page --------------------------------
      WRITE(17,ENDPAGE) Epilog ! Epilog must be for the end of file
!----------------------------------------------------------------
      CLOSE(17,ERR=22222)
      STOP
11111 STOP 'Bad file name'
22222 STOP 'Error writing PostScript'
END PROGRAM POSTSCRIPT_DEMO
