C     Copyright (c) M. Yas'ko. E-mail: yasko@ftf.dsu.dp.ua
      PROGRAM DEMOPS
C    We have to choice one variant for include:
*$INCLUDE PSFMT.FI
*$INCLUDE RGB.FI
C    Other variant for include
*     include 'PSFMT.FI'
*     include 'RGB.FI'
      REAL X(4)/.03,.69,.95,.35/, Y(4)/.46,.48,.52,.53/
      REAL XT(4)/.3,.32,.32,.3/, YT(4)/.5,.5,.6,.6/
      REAL XC(5)/.29,.33,.3,.32,.31/, YC(5)/.56,.56,.58,.58,.59/
      REAL XO/.15/, YO/.9/, RAD/15./

      OPEN(UNIT=17, FILE='DEMO.PS', ERR=11111)
      WRITE(17,PROLOG,ERR=22222) POSTSCRIPT, WithMathText
      WRITE(17,BeginPage) 1
C-- Write hollow rectangle in point (0,0) with sides 180,240mm --
      WRITE(17,Rectan) 0.,0.,180.,240.
C----------Set RGB color - BLACK  is array from 3 elements ------
      WRITE(17,COLOR)  BLACK
C----------------------------------------------------------------
C------- Set font Times-Bold, 36pt -----------------------------
      WRITE(17,FONT) 'Times-Bold', 36
C----------------------------------------------------------------
C---------- Write text: Title 'cc' is alingment as in LaTeX -----
      WRITE(17,TEXT) 0.504,0.953, 'PostScript_Demo', 'cc'
      WRITE(17,COLOR)  RED
      WRITE(17,TEXT) 0.5,0.95, 'PostScript_Demo', 'cc'
C----------------------------------------------------------------
C----------Set Line Style - LineWidth [,LineType]----------------
      WRITE(17,LineType) Thin, Solid
C------- Filed Circle (disk) (radius - in mm) -------------------
      WRITE(17,COLOR)  Yellow
      WRITE(17,CIRCLE) CMPLX(XO,YO),RAD,Filled
      WRITE(17,COLOR)  (YELLOW(I)*0.9, I=1,NumColors)
C-------------- Hollow circle -----------------------------------
      WRITE(17,CIRCLE) CMPLX(XO,YO),RAD
C----------------------------------------------------------------
C-------- Arrows (8) ---------------------------------------------
      WRITE(17,ARROW) ( CMPLX(XO,YO)+.1*EXP((0.,-.3)*i),
     ,                 CMPLX(XO,YO)+.2*EXP((0.,-.3)*i), i=0,7)
C----------------------------------------------------------------
      WRITE(17,COLOR)  Blue
C------- Circle (radius in mm) ----------------------------------
      WRITE(17,CIRCLE) .6,.8,   14., Filled
      WRITE(17,CIRCLE) .5,.78,  14., Filled
      WRITE(17,CIRCLE) .71,.82, 14., Filled
      WRITE(17,CIRCLE) .55,.76, 14., Filled
      WRITE(17,CIRCLE) .53,.81, 14., Filled
      WRITE(17,CIRCLE) .66,.84, 14., Filled
      WRITE(17,CIRCLE) .60,.83, 14., Filled
C--------- Set LineType: .1pt, Dashed line ---------------------
      WRITE(17,LineType) Thin, Dashed
C----------------------------------------------------------------
C----------- PolyLine -------------------------------------------
      WRITE(17,PolyLine) .55,.65, .55,.45
      WRITE(17,PolyLine) .65,.68, .65,.48
      WRITE(17,PolyLine) .75,.72, .75,.49
      WRITE(17,LineType) Thick, Solid
C----------------------------------------------------------------
C------------ New co-ordinates Xmin,Xmax, Ymin,Ymax -------------
C---- (default coordinates is   0  - 1      0 - 1  ) ------------
      WRITE(17,SetCoOrd) 0., 180.,   0.,240.
C----------------------------------------------------------------
C------- Set font Helvetica, 12pt (default) ---------------------
      WRITE(17,FONT) 'Helvetica'
      WRITE(17,COLOR)  Black
C--! Alignment (top, center)
      WRITE(17,TEXT) 170.,10., 'x', 'tc'
C--! Alignment (center, right)
      WRITE(17,TEXT)  90.,90., 'y', 'cr'
C--! Alignment (top, right)
      WRITE(17,TEXT)  90.,10., 'O', 'tr'
      WRITE(17,TEXT) 130., 5., 'Fig. Parabola', 'cc'

C-------- Set ViewPort  (Xo,Yo, DX,DY in mm) ------------
      WRITE(17,SetViewPort) 90.,10.,80.,80.
C----------------------------------------------------------------
      WRITE(17,COLOR)  BLACK
      WRITE(17,Rectan) 90.,10.,80.,80.
C-------- Set co-ordinates (Xmin,Xmax, Ymin,Ymax) ---------------
      WRITE(17,SetCoOrd) 0., 1.,  0.,1.
C----------------------------------------------------------------
      WRITE(17,MathText) 0.15,0.60, 'y_@a| = x^2|'
      WRITE(17,PolyLine) (i*0.05,(i*0.05)**2, I=0,20)
      WRITE(17,Marker) 0.1, 0.06, Dot
      WRITE(17,Marker) 0.2, 0.025, Bullet
      WRITE(17,Marker) 0.3, 0.11, Plus
      WRITE(17,Marker) 0.4, 0.14, Times
      WRITE(17,Marker) 0.5, 0.27, Circ,     0.6, 0.39, ast
      WRITE(17,Marker) 0.7, 0.52, dimond

C--! Restore old viewport and graphics state
      WRITE(17,SetViewPort)

C--! Set gray color
      WRITE(17,COLOR)  0.56
C----------------------------------------------------------------

C----------- Shaded POLIGON -------------------------------------
      WRITE(17,COLOR)  GREEN
      WRITE(17,SHADE) ( X(I),Y(I), I=1,4)
      WRITE(17,COLOR)  0.15
      WRITE(17,POLYGON) X(1),Y(1)-.02,X(2),Y(2)-.02,X(2),Y(2),X(1),Y(1)
      WRITE(17,COLOR)  0.30  ! GrayColor!
      WRITE(17,POLYGON) X(2),Y(2)-.02,X(3),Y(3)-.02,X(3),Y(3),X(2),Y(2)
      WRITE(17,COLOR)  BRAWN
      WRITE(17,POLYGON) ( XT(I),YT(I), I=1,4)
      WRITE(17,COLOR)  (GREEN(I)*0.8, I=1,NumColors)
      WRITE(17,CIRCLE) (XC(I),YC(I), 6., Filled, I=1,5)

      WRITE(17,FONT) 'Times-Roman', 16
C--! Text slope is 10 degrees
      WRITE(17,TEXT) 0.2,0.41, 'Poligons', 'cc',10
      WRITE(17,COLOR) 0.
      WRITE(17,FONT) 'Times-Italic', 14
      WRITE(17,TEXT) 0.05,0.30, 'I hope, this example of vector'
      WRITE(17,TEXT) 0.05,0.26, 'postscript graphics will be useful'
      WRITE(17,TEXT) 0.05,0.22, 'for users of Fortran-77.'
      WRITE(17,TEXT) 0.20,0.18, 'Nick Yas''ko'
C----------------------------------------------------------------
C------------- It is END of page --------------------------------
      WRITE(17,ENDPAGE)
C------------- It is a second page ------------------------------
      Write(17,BeginPage) 2
      WRITE(17,COLOR) 0.9, 0.9, 0.9
      WRITE(17,RECTAN) 10., 50., 100.,100.
      WRITE(17,COLOR) BLACK
      WRITE(17,SetViewPort) 10.,50., 100.,100.
      WRITE(17,SetCoOrd) -2., 2.,  -2.,2.
      WRITE(17,ARROW)  -1.9, 0.,   1.9, 0.
      WRITE(17,ARROW)  0.,-1.9,    0., 1.9
      WRITE(17,LineType) Thick, Solid
      WRITE(17,PolyLine) ((U**2-1)/(U**2+1),U*(U**2-1)/(U**2+1),
     ,   U=-4,4,.1)
      WRITE(17,LineType) Thin, Dashed
      WRITE(17,PolyLine)  1.,-1.9, 1., 1.9

C------------- It is END of page and END of file ----------------
      WRITE(17,ENDPAGE) Epilog
C----------------------------------------------------------------
      CLOSE(17,ERR=22222)
      STOP
11111 STOP 'Bad file name'
22222 STOP 'Error writing PostScript'
      END
